/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.gebietsbaum.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.gebietsbaum.entity.Gebietsgruppierung;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractGebietsgruppierungSearch {

  @Inject
  protected transient GebietsgruppierungExtendedDAO dao;

  public AbstractGebietsgruppierungSearch() {
    super();
  }

  public List<Gebietsgruppierung> getSearchResult(GebietsgruppierungSearchParameters searchParameters, EagerLoadingCollector<Gebietsgruppierung> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Gebietsgruppierung> querySearchResult(GebietsgruppierungSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
